Index: trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableCollection.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableCollection.cs	(revision 3317)
@@ -34,4 +34,9 @@
 
     #region Properties
+    public bool ReadOnlyView {
+      get { return true; }
+      set { throw new NotSupportedException(); }
+    }
+
     public int Count {
       get { return collection.Count; }
@@ -95,9 +100,14 @@
     }
 
+    event EventHandler IObservableCollection<T>.ReadOnlyViewChanged {
+      add { }
+      remove { }
+    }
+
     [field: NonSerialized]
     public event CollectionItemsChangedEventHandler<T> ItemsAdded;
     protected virtual void OnItemsAdded(IEnumerable<T> items) {
-      if (ItemsAdded != null)
-        ItemsAdded(this, new CollectionItemsChangedEventArgs<T>(items));
+      CollectionItemsChangedEventHandler<T> handler = ItemsAdded;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<T>(items));
     }
 
@@ -105,6 +115,6 @@
     public event CollectionItemsChangedEventHandler<T> ItemsRemoved;
     protected virtual void OnItemsRemoved(IEnumerable<T> items) {
-      if (ItemsRemoved != null)
-        ItemsRemoved(this, new CollectionItemsChangedEventArgs<T>(items));
+      CollectionItemsChangedEventHandler<T> handler = ItemsRemoved;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<T>(items));
     }
 
@@ -112,6 +122,6 @@
     public event CollectionItemsChangedEventHandler<T> CollectionReset;
     protected virtual void OnCollectionReset(IEnumerable<T> items, IEnumerable<T> oldItems) {
-      if (CollectionReset != null)
-        CollectionReset(this, new CollectionItemsChangedEventArgs<T>(items, oldItems));
+      CollectionItemsChangedEventHandler<T> handler = CollectionReset;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<T>(items, oldItems));
     }
 
@@ -119,6 +129,6 @@
     public event PropertyChangedEventHandler PropertyChanged;
     protected virtual void OnPropertyChanged(string propertyName) {
-      if (PropertyChanged != null)
-        PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
+      PropertyChangedEventHandler handler = PropertyChanged;
+      if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
     }
 
Index: trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableDictionary.cs
===================================================================
--- trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableDictionary.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableDictionary.cs	(revision 3317)
@@ -34,4 +34,9 @@
 
     #region Properties
+    public bool ReadOnlyView {
+      get { return true; }
+      set { throw new NotSupportedException(); }
+    }
+
     public ICollection<TKey> Keys {
       get { return dict.Keys; }
@@ -123,9 +128,14 @@
     }
 
+    event EventHandler IObservableCollection<KeyValuePair<TKey, TValue>>.ReadOnlyViewChanged {
+      add { }
+      remove { }
+    }
+
     [field: NonSerialized]
     public event CollectionItemsChangedEventHandler<KeyValuePair<TKey, TValue>> ItemsAdded;
     protected virtual void OnItemsAdded(IEnumerable<KeyValuePair<TKey, TValue>> items) {
-      if (ItemsAdded != null)
-        ItemsAdded(this, new CollectionItemsChangedEventArgs<KeyValuePair<TKey, TValue>>(items));
+      CollectionItemsChangedEventHandler<KeyValuePair<TKey, TValue>> handler = ItemsAdded;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<KeyValuePair<TKey, TValue>>(items));
     }
 
@@ -133,6 +143,6 @@
     public event CollectionItemsChangedEventHandler<KeyValuePair<TKey, TValue>> ItemsRemoved;
     protected virtual void OnItemsRemoved(IEnumerable<KeyValuePair<TKey, TValue>> items) {
-      if (ItemsRemoved != null)
-        ItemsRemoved(this, new CollectionItemsChangedEventArgs<KeyValuePair<TKey, TValue>>(items));
+      CollectionItemsChangedEventHandler<KeyValuePair<TKey, TValue>> handler = ItemsRemoved;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<KeyValuePair<TKey, TValue>>(items));
     }
 
@@ -140,6 +150,6 @@
     public event CollectionItemsChangedEventHandler<KeyValuePair<TKey, TValue>> ItemsReplaced;
     protected virtual void OnItemsReplaced(IEnumerable<KeyValuePair<TKey, TValue>> items, IEnumerable<KeyValuePair<TKey, TValue>> oldItems) {
-      if (ItemsReplaced != null)
-        ItemsReplaced(this, new CollectionItemsChangedEventArgs<KeyValuePair<TKey, TValue>>(items, oldItems));
+      CollectionItemsChangedEventHandler<KeyValuePair<TKey, TValue>> handler = ItemsReplaced;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<KeyValuePair<TKey, TValue>>(items, oldItems));
     }
 
@@ -147,6 +157,6 @@
     public event CollectionItemsChangedEventHandler<KeyValuePair<TKey, TValue>> CollectionReset;
     protected virtual void OnCollectionReset(IEnumerable<KeyValuePair<TKey, TValue>> items, IEnumerable<KeyValuePair<TKey, TValue>> oldItems) {
-      if (CollectionReset != null)
-        CollectionReset(this, new CollectionItemsChangedEventArgs<KeyValuePair<TKey, TValue>>(items, oldItems));
+      CollectionItemsChangedEventHandler<KeyValuePair<TKey, TValue>> handler = CollectionReset;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<KeyValuePair<TKey, TValue>>(items, oldItems));
     }
 
@@ -154,6 +164,6 @@
     public event PropertyChangedEventHandler PropertyChanged;
     protected virtual void OnPropertyChanged(string propertyName) {
-      if (PropertyChanged != null)
-        PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
+      PropertyChangedEventHandler handler = PropertyChanged;
+      if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
     }
 
Index: trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableKeyedCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableKeyedCollection.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableKeyedCollection.cs	(revision 3317)
@@ -34,4 +34,9 @@
 
     #region Properties
+    public bool ReadOnlyView {
+      get { return true; }
+      set { throw new NotSupportedException(); }
+    }
+
     public int Count {
       get { return collection.Count; }
@@ -112,9 +117,14 @@
     }
 
+    event EventHandler IObservableCollection<TItem>.ReadOnlyViewChanged {
+      add { }
+      remove { }
+    }
+
     [field: NonSerialized]
     public event CollectionItemsChangedEventHandler<TItem> ItemsAdded;
     protected virtual void OnItemsAdded(IEnumerable<TItem> items) {
-      if (ItemsAdded != null)
-        ItemsAdded(this, new CollectionItemsChangedEventArgs<TItem>(items));
+      CollectionItemsChangedEventHandler<TItem> handler = ItemsAdded;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<TItem>(items));
     }
 
@@ -122,6 +132,6 @@
     public event CollectionItemsChangedEventHandler<TItem> ItemsRemoved;
     protected virtual void OnItemsRemoved(IEnumerable<TItem> items) {
-      if (ItemsRemoved != null)
-        ItemsRemoved(this, new CollectionItemsChangedEventArgs<TItem>(items));
+      CollectionItemsChangedEventHandler<TItem> handler = ItemsRemoved;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<TItem>(items));
     }
 
@@ -129,6 +139,6 @@
     public event CollectionItemsChangedEventHandler<TItem> ItemsReplaced;
     protected virtual void OnItemsReplaced(IEnumerable<TItem> items, IEnumerable<TItem> oldItems) {
-      if (ItemsReplaced != null)
-        ItemsReplaced(this, new CollectionItemsChangedEventArgs<TItem>(items, oldItems));
+      CollectionItemsChangedEventHandler<TItem> handler = ItemsReplaced;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<TItem>(items, oldItems));
     }
 
@@ -136,6 +146,6 @@
     public event CollectionItemsChangedEventHandler<TItem> CollectionReset;
     protected virtual void OnCollectionReset(IEnumerable<TItem> items, IEnumerable<TItem> oldItems) {
-      if (CollectionReset != null)
-        CollectionReset(this, new CollectionItemsChangedEventArgs<TItem>(items, oldItems));
+      CollectionItemsChangedEventHandler<TItem> handler = CollectionReset;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<TItem>(items, oldItems));
     }
 
@@ -143,6 +153,6 @@
     public event PropertyChangedEventHandler PropertyChanged;
     protected virtual void OnPropertyChanged(string propertyName) {
-      if (PropertyChanged != null)
-        PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
+      PropertyChangedEventHandler handler = PropertyChanged;
+      if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
     }
 
Index: trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableList.cs
===================================================================
--- trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableList.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableList.cs	(revision 3317)
@@ -34,4 +34,9 @@
 
     #region Properties
+    public bool ReadOnlyView {
+      get { return true; }
+      set { throw new NotSupportedException(); }
+    }
+
     public int Count {
       get { return ((ICollection<T>)list).Count; }
@@ -119,9 +124,14 @@
     }
 
+    event EventHandler IObservableCollection<T>.ReadOnlyViewChanged {
+      add { }
+      remove { }
+    }
+
     [field: NonSerialized]
     public event CollectionItemsChangedEventHandler<IndexedItem<T>> ItemsAdded;
     protected virtual void OnItemsAdded(IEnumerable<IndexedItem<T>> items) {
-      if (ItemsAdded != null)
-        ItemsAdded(this, new CollectionItemsChangedEventArgs<IndexedItem<T>>(items));
+      CollectionItemsChangedEventHandler<IndexedItem<T>> handler = ItemsAdded;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<IndexedItem<T>>(items));
     }
 
@@ -133,6 +143,6 @@
     }
     private void OnItemsAdded(IEnumerable<T> items) {
-      if (itemsAdded != null)
-        itemsAdded(this, new CollectionItemsChangedEventArgs<T>(items));
+      CollectionItemsChangedEventHandler<T> handler = itemsAdded;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<T>(items));
     }
 
@@ -140,6 +150,6 @@
     public event CollectionItemsChangedEventHandler<IndexedItem<T>> ItemsRemoved;
     protected virtual void OnItemsRemoved(IEnumerable<IndexedItem<T>> items) {
-      if (ItemsRemoved != null)
-        ItemsRemoved(this, new CollectionItemsChangedEventArgs<IndexedItem<T>>(items));
+      CollectionItemsChangedEventHandler<IndexedItem<T>> handler = ItemsRemoved;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<IndexedItem<T>>(items));
     }
 
@@ -151,6 +161,6 @@
     }
     private void OnItemsRemoved(IEnumerable<T> items) {
-      if (itemsRemoved != null)
-        itemsRemoved(this, new CollectionItemsChangedEventArgs<T>(items));
+      CollectionItemsChangedEventHandler<T> handler = itemsRemoved;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<T>(items));
     }
 
@@ -158,6 +168,6 @@
     public event CollectionItemsChangedEventHandler<IndexedItem<T>> ItemsReplaced;
     protected virtual void OnItemsReplaced(IEnumerable<IndexedItem<T>> items, IEnumerable<IndexedItem<T>> oldItems) {
-      if (ItemsReplaced != null)
-        ItemsReplaced(this, new CollectionItemsChangedEventArgs<IndexedItem<T>>(items, oldItems));
+      CollectionItemsChangedEventHandler<IndexedItem<T>> handler = ItemsReplaced;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<IndexedItem<T>>(items, oldItems));
     }
 
@@ -165,6 +175,6 @@
     public event CollectionItemsChangedEventHandler<IndexedItem<T>> ItemsMoved;
     protected virtual void OnItemsMoved(IEnumerable<IndexedItem<T>> items, IEnumerable<IndexedItem<T>> oldItems) {
-      if (ItemsMoved != null)
-        ItemsMoved(this, new CollectionItemsChangedEventArgs<IndexedItem<T>>(items, oldItems));
+      CollectionItemsChangedEventHandler<IndexedItem<T>> handler = ItemsMoved;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<IndexedItem<T>>(items, oldItems));
     }
 
@@ -172,6 +182,6 @@
     public event CollectionItemsChangedEventHandler<IndexedItem<T>> CollectionReset;
     protected virtual void OnCollectionReset(IEnumerable<IndexedItem<T>> items, IEnumerable<IndexedItem<T>> oldItems) {
-      if (CollectionReset != null)
-        CollectionReset(this, new CollectionItemsChangedEventArgs<IndexedItem<T>>(items, oldItems));
+      CollectionItemsChangedEventHandler<IndexedItem<T>> handler = CollectionReset;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<IndexedItem<T>>(items, oldItems));
     }
 
@@ -183,6 +193,6 @@
     }
     private void OnCollectionReset(IEnumerable<T> items, IEnumerable<T> oldItems) {
-      if (collectionReset != null)
-        collectionReset(this, new CollectionItemsChangedEventArgs<T>(items, oldItems));
+      CollectionItemsChangedEventHandler<T> handler = collectionReset;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<T>(items, oldItems));
     }
 
@@ -190,6 +200,6 @@
     public event PropertyChangedEventHandler PropertyChanged;
     protected virtual void OnPropertyChanged(string propertyName) {
-      if (PropertyChanged != null)
-        PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
+      PropertyChangedEventHandler handler = PropertyChanged;
+      if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
     }
 
Index: trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableSet.cs
===================================================================
--- trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableSet.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Collections/3.3/ReadOnlyObservableSet.cs	(revision 3317)
@@ -34,4 +34,9 @@
 
     #region Properties
+    public bool ReadOnlyView {
+      get { return true; }
+      set { throw new NotSupportedException(); }
+    }
+
     public int Count {
       get { return set.Count; }
@@ -136,9 +141,14 @@
     }
 
+    event EventHandler IObservableCollection<T>.ReadOnlyViewChanged {
+      add { }
+      remove { }
+    }
+
     [field: NonSerialized]
     public event CollectionItemsChangedEventHandler<T> ItemsAdded;
     protected virtual void OnItemsAdded(IEnumerable<T> items) {
-      if (ItemsAdded != null)
-        ItemsAdded(this, new CollectionItemsChangedEventArgs<T>(items));
+      CollectionItemsChangedEventHandler<T> handler = ItemsAdded;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<T>(items));
     }
 
@@ -146,6 +156,6 @@
     public event CollectionItemsChangedEventHandler<T> ItemsRemoved;
     protected virtual void OnItemsRemoved(IEnumerable<T> items) {
-      if (ItemsRemoved != null)
-        ItemsRemoved(this, new CollectionItemsChangedEventArgs<T>(items));
+      CollectionItemsChangedEventHandler<T> handler = ItemsRemoved;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<T>(items));
     }
 
@@ -153,6 +163,6 @@
     public event CollectionItemsChangedEventHandler<T> CollectionReset;
     protected virtual void OnCollectionReset(IEnumerable<T> items, IEnumerable<T> oldItems) {
-      if (CollectionReset != null)
-        CollectionReset(this, new CollectionItemsChangedEventArgs<T>(items, oldItems));
+      CollectionItemsChangedEventHandler<T> handler = CollectionReset;
+      if (handler != null) handler(this, new CollectionItemsChangedEventArgs<T>(items, oldItems));
     }
 
@@ -160,6 +170,6 @@
     public event PropertyChangedEventHandler PropertyChanged;
     protected virtual void OnPropertyChanged(string propertyName) {
-      if (PropertyChanged != null)
-        PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
+      PropertyChangedEventHandler handler = PropertyChanged;
+      if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
     }
 
Index: trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 3317)
@@ -280,5 +280,5 @@
       T item = (T)listViewItem.Tag;
       int i = 0;
-      while ((i < itemsListView.SmallImageList.Images.Count) && (item.ItemImage != itemsListView.SmallImageList.Images[i]))
+      while ((i < itemsListView.SmallImageList.Images.Count) && !item.ItemImage.Equals(itemsListView.SmallImageList.Images[i]))
         i++;
       if (i == itemsListView.SmallImageList.Images.Count) itemsListView.SmallImageList.Images.Add(item.ItemImage);
Index: trunk/sources/HeuristicLab.Core/3.3/ExecutionContext.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/ExecutionContext.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/ExecutionContext.cs	(revision 3317)
@@ -26,5 +26,5 @@
 namespace HeuristicLab.Core {
   [StorableClass]
-  public class ExecutionContext : DeepCloneable, IExecutionContext, IAtomicOperation {
+  public sealed class ExecutionContext : DeepCloneable, IExecutionContext, IAtomicOperation {
     [Storable]
     private IParameterizedItem parameterizedItem;
Index: trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItem.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItem.cs	(revision 3317)
@@ -32,5 +32,8 @@
     Image ItemImage { get; }
 
+    bool ReadOnlyView { get; set; }
+
     event EventHandler ItemImageChanged;
+    event EventHandler ReadOnlyViewChanged;
     event EventHandler ToStringChanged;
   }
Index: trunk/sources/HeuristicLab.Core/3.3/Item.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Item.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/Item.cs	(revision 3317)
@@ -22,5 +22,4 @@
 using System;
 using System.Drawing;
-using HeuristicLab.Common.Resources;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -39,11 +38,37 @@
     }
     public virtual Image ItemImage {
-      get { return VS2008ImageLibrary.Class; }
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Class; }
     }
 
-    protected Item() : base() { }
+    [Storable]
+    private bool readOnlyView;
+    public bool ReadOnlyView {
+      get { return readOnlyView; }
+      set {
+        if (readOnlyView != value) {
+          readOnlyView = value;
+          OnReadOnlyViewChanged();
+        }
+      }
+    }
+
+    protected Item()
+      : base() {
+      readOnlyView = false;
+    }
     [StorableConstructor]
     protected Item(bool deserializing) : base(deserializing) { }
 
+
+    /// <summary>
+    /// Clones the current instance (deep clone).
+    /// </summary>
+    /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
+    /// <returns>The cloned object as <see cref="Variable"/>.</returns>
+    public override IDeepCloneable Clone(Cloner cloner) {
+      Item clone = (Item)base.Clone(cloner);
+      clone.readOnlyView = readOnlyView;
+      return clone;
+    }
 
     /// <summary>
@@ -60,4 +85,9 @@
       if (handler != null) handler(this, EventArgs.Empty);
     }
+    public event EventHandler ReadOnlyViewChanged;
+    protected virtual void OnReadOnlyViewChanged() {
+      EventHandler handler = ReadOnlyViewChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
     public event EventHandler ToStringChanged;
     protected virtual void OnToStringChanged() {
Index: trunk/sources/HeuristicLab.Core/3.3/ItemArray.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/ItemArray.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/ItemArray.cs	(revision 3317)
@@ -57,4 +57,5 @@
       ItemArray<T> clone = (ItemArray<T>)Activator.CreateInstance(this.GetType());
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       clone.array = this.Select(x => (T)cloner.Clone(x)).ToArray();
       return clone;
Index: trunk/sources/HeuristicLab.Core/3.3/ItemCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/ItemCollection.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/ItemCollection.cs	(revision 3317)
@@ -53,4 +53,5 @@
       ItemCollection<T> clone = (ItemCollection<T>)Activator.CreateInstance(this.GetType());
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       clone.list = new List<T>(this.Select(x => (T)cloner.Clone(x)));
       return clone;
Index: trunk/sources/HeuristicLab.Core/3.3/ItemList.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/ItemList.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/ItemList.cs	(revision 3317)
@@ -57,4 +57,5 @@
       ItemList<T> clone = (ItemList<T>)Activator.CreateInstance(this.GetType());
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       clone.list = new List<T>(this.Select(x => (T)cloner.Clone(x)));
       return clone;
Index: trunk/sources/HeuristicLab.Core/3.3/ItemSet.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/ItemSet.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/ItemSet.cs	(revision 3317)
@@ -56,4 +56,5 @@
       ItemSet<T> clone = (ItemSet<T>)Activator.CreateInstance(this.GetType());
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       clone.set = new HashSet<T>(this.Select(x => (T)cloner.Clone(x)));
       return clone;
Index: trunk/sources/HeuristicLab.Core/3.3/NamedItemCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/NamedItemCollection.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/NamedItemCollection.cs	(revision 3317)
@@ -49,5 +49,5 @@
 
     [StorableHook(HookType.AfterDeserialization)]
-    private void Initialize() {
+    protected void Initialize() {
       RegisterItemEvents(this);
     }
@@ -59,4 +59,5 @@
       NamedItemCollection<T> clone = (NamedItemCollection<T>)Activator.CreateInstance(this.GetType());
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       foreach (string key in dict.Keys)
         clone.dict.Add(key, (T)cloner.Clone(dict[key]));
Index: trunk/sources/HeuristicLab.Core/3.3/OperationCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/OperationCollection.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/OperationCollection.cs	(revision 3317)
@@ -26,5 +26,5 @@
 namespace HeuristicLab.Core {
   [StorableClass]
-  public class OperationCollection : DeepCloneable, IList<IOperation>, IOperation {
+  public sealed class OperationCollection : DeepCloneable, IList<IOperation>, IOperation {
     [Storable]
     private IList<IOperation> operations;
@@ -51,6 +51,6 @@
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      OperationCollection clone = new OperationCollection(this.Select(x => (IOperation)cloner.Clone(x)));
-      cloner.RegisterClonedObject(this, clone);
+      OperationCollection clone = (OperationCollection)base.Clone(cloner);
+      clone.operations = new List<IOperation>(this.Select(x => (IOperation)cloner.Clone(x)));
       clone.parallel = parallel;
       return clone;
Index: trunk/sources/HeuristicLab.Core/3.3/OperatorGraph.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/OperatorGraph.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/OperatorGraph.cs	(revision 3317)
@@ -37,16 +37,11 @@
   [StorableClass]
   public class OperatorGraph : Item {
+    [Storable]
     private OperatorSet operators;
     /// <summary>
     /// Gets all operators of the current instance.
     /// </summary>
-    [Storable]
     public OperatorSet Operators {
       get { return operators; }
-      private set {
-        DeregisterOperatorsEvents();
-        operators = value;
-        RegisterOperatorsEvents();
-      }
     }
 
@@ -87,7 +82,15 @@
     /// </summary>
     public OperatorGraph() {
-      Operators = new OperatorSet();
+      operators = new OperatorSet();
       initialOperator = null;
       visualizationInfo = null;
+      Initialize();
+    }
+    [StorableConstructor]
+    protected OperatorGraph(bool deserializing) : base(deserializing) { }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      RegisterOperatorsEvents();
     }
 
@@ -100,9 +103,9 @@
     /// <returns>The cloned object as <see cref="OperatorGraph"/>.</returns>
     public override IDeepCloneable Clone(Cloner cloner) {
-      OperatorGraph clone = new OperatorGraph();
-      cloner.RegisterClonedObject(this, clone);
-      clone.Operators = (OperatorSet)cloner.Clone(operators);
+      OperatorGraph clone = (OperatorGraph)base.Clone(cloner);
+      clone.operators = (OperatorSet)cloner.Clone(operators);
       clone.initialOperator = (IOperator)cloner.Clone(initialOperator);
       clone.visualizationInfo = cloner.Clone(visualizationInfo);
+      clone.Initialize();
       return clone;
     }
@@ -166,18 +169,4 @@
       }
     }
-    private void DeregisterOperatorsEvents() {
-      if (operators != null) {
-        foreach (IOperator op in operators) {
-          foreach (IParameter param in op.Parameters) {
-            IValueParameter<IOperator> opParam = param as IValueParameter<IOperator>;
-            if (opParam != null) DeregisterOperatorParameterEvents(opParam);
-          }
-          DeregisterOperatorEvents(op);
-        }
-        operators.ItemsAdded -= new CollectionItemsChangedEventHandler<IOperator>(Operators_ItemsAdded);
-        operators.ItemsRemoved -= new CollectionItemsChangedEventHandler<IOperator>(Operators_ItemsRemoved);
-        operators.CollectionReset -= new CollectionItemsChangedEventHandler<IOperator>(Operators_CollectionReset);
-      }
-    }
     private void RegisterOperatorEvents(IOperator op) {
       op.Parameters.ItemsAdded += new CollectionItemsChangedEventHandler<IParameter>(Parameters_ItemsAdded);
Index: trunk/sources/HeuristicLab.Core/3.3/Scope.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Scope.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/Scope.cs	(revision 3317)
@@ -51,13 +51,8 @@
     }
 
+    [Storable]
     private ScopeList subScopes;
-    [Storable]
     public ScopeList SubScopes {
       get { return subScopes; }
-      private set {
-        DeregisterSubScopesEvents();
-        subScopes = value;
-        RegisterSubScopesEvents();
-      }
     }
 
@@ -69,5 +64,6 @@
       parent = null;
       variables = new VariableCollection();
-      SubScopes = new ScopeList();
+      subScopes = new ScopeList();
+      Initialize();
     }
     /// <summary>
@@ -79,5 +75,6 @@
       parent = null;
       variables = new VariableCollection();
-      SubScopes = new ScopeList();
+      subScopes = new ScopeList();
+      Initialize();
     }
     public Scope(string name, string description)
@@ -85,5 +82,13 @@
       parent = null;
       variables = new VariableCollection();
-      SubScopes = new ScopeList();
+      subScopes = new ScopeList();
+      Initialize();
+    }
+    [StorableConstructor]
+    private Scope(bool deserializing) : base(deserializing) { }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      RegisterSubScopesEvents();
     }
 
@@ -98,11 +103,13 @@
       Scope clone = new Scope();
       cloner.RegisterClonedObject(this, clone);
-      clone.Name = Name;
-      clone.Description = Description;
+      clone.ReadOnlyView = ReadOnlyView;
+      clone.name = name;
+      clone.description = description;
       if (variables.Count > 0) clone.variables = (VariableCollection)cloner.Clone(variables);
       if (subScopes.Count > 0) {
-        clone.SubScopes = (ScopeList)cloner.Clone(subScopes);
+        clone.subScopes = (ScopeList)cloner.Clone(subScopes);
         foreach (IScope child in clone.SubScopes)
           child.Parent = clone;
+        clone.Initialize();
       }
       return clone;
@@ -116,12 +123,4 @@
         subScopes.ItemsReplaced += new CollectionItemsChangedEventHandler<IndexedItem<IScope>>(SubScopes_ItemsReplaced);
         subScopes.CollectionReset += new CollectionItemsChangedEventHandler<IndexedItem<IScope>>(SubScopes_CollectionReset);
-      }
-    }
-    private void DeregisterSubScopesEvents() {
-      if (subScopes != null) {
-        subScopes.ItemsAdded -= new CollectionItemsChangedEventHandler<IndexedItem<IScope>>(SubScopes_ItemsAdded);
-        subScopes.ItemsRemoved -= new CollectionItemsChangedEventHandler<IndexedItem<IScope>>(SubScopes_ItemsRemoved);
-        subScopes.ItemsReplaced -= new CollectionItemsChangedEventHandler<IndexedItem<IScope>>(SubScopes_ItemsReplaced);
-        subScopes.CollectionReset -= new CollectionItemsChangedEventHandler<IndexedItem<IScope>>(SubScopes_CollectionReset);
       }
     }
Index: trunk/sources/HeuristicLab.Core/3.3/ScopeList.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/ScopeList.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/ScopeList.cs	(revision 3317)
@@ -33,6 +33,8 @@
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      ScopeList clone = new ScopeList(this.Select(x => (IScope)cloner.Clone(x)));
+      ScopeList clone = new ScopeList();
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
+      clone.list = new List<IScope>(this.Select(x => (IScope)cloner.Clone(x)));
       return clone;
     }
